/**

Este cdigo crea 10 hilos. Cada hilo toma el valor de una variable contador, lo incrementa en 1
y lo guarda. Esta operacin se repite 10 veces

Dado que son hilos, todos acceden a la misma variable.

El acceso a la variable contador se ha sincronizado mediante un semforo.

**/

public class Ejemplo
    implements Runnable
{
  
  long counter;
  final static long HIJOS = (long)10;
  final static long OPERATIONS = (long)10;

  Semaphore semaph;

  /**
    * Contructor. Inicializa los atributos y crea el semforo
    **/
  public Ejemplo() {
    counter = 0;
    // Por defecto el valor del contador de semforo es 1.
    semaph = new Semaphore();
  }
  
  
  /**
    * Este mtodo ser ejecutado por cada hilo
    **/
  public void run() 
  {
    long tmp;
    int c;
    
    for (c = 0; c < OPERATIONS; c++) {
      try {
        semaph.acquire();
        tmp = counter;
        tmp++;
        counter = tmp;
        semaph.release();
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
    
    return;
  }

  /**
    * Con este mtodo se crean los hilos
    **/
  public void launch() 
    throws InterruptedException
  {
    int c;
    Thread hilo;

    for (c = 0; c < HIJOS; c++) {
      System.out.print(c+ " | ");
      hilo = new Thread(this);
      hilo.start();
    }
    
    
    Thread.sleep(2);
    
    return ;
  }
  
  /**
    * Muestra los reusltados
    **/
  public void showStat() {
    System.out.println("\nExpected result: "+OPERATIONS*HIJOS);
    System.out.println("Real result: "+counter);
    System.out.println("Diference: "+((OPERATIONS*HIJOS) - counter));

  }
  
  
  /**
    * Punto de entrada
    **/
  public static void main(String[] args) 
    throws Exception
  {
    Ejemplo s = new Ejemplo();
    s.launch();
    s.showStat();
  }
  
}